@echo off
setlocal ENABLEEXTENSIONS DISABLEDELAYEDEXPANSION
pushd "%~dp0"
set log=MinGW EDuke32 Setup Helper.log
set tee=tee.exe -a "%log%"
echo MinGW EDuke32 Setup Helper started at: %date% %time% | %tee%

:path
set mingw=C:\MinGW\bin
set msys=C:\MinGW\msys\1.0\bin

for /f "tokens=*" %%G in ('setenv.exe -m PATH') do set pathtemp=%%~G
echo PATH backup: %pathtemp:"=% >>"%log%"

:pathmingw
for /f "tokens=*" %%G in ('setenv.exe -m PATH') do set pathtemp=%%~G
echo %pathtemp% | grep.exe -q -i "%mingw:\=\\%"
if "%ERRORLEVEL%"=="0" goto pathmingw_end
echo Adding MinGW to PATH.
echo Adding MinGW to PATH: %pathtemp:"=%;%mingw% >>"%log%"
setenv.exe -m PATH "%pathtemp:"=%;%mingw%"
set PATH=%PATH%;%mingw%
:pathmingw_end

:pathmsys
for /f "tokens=*" %%G in ('setenv.exe -m PATH') do set pathtemp=%%~G
echo %pathtemp% | grep.exe -q -i "%msys:\=\\%"
if "%ERRORLEVEL%"=="0" goto pathmsys_end
echo Adding MSYS to PATH.
echo Adding MSYS to PATH: %pathtemp:"=%;%msys% >>"%log%"
setenv.exe -m PATH "%pathtemp:"=%;%msys%"
set PATH=%PATH%;%msys%
:pathmsys_end

:mingw
if not exist "%mingw%" echo MinGW not detected! http://wiki.eduke32.com/wiki/Building_EDuke32_on_Windows | %tee%

:nasm
for %%G in (nasm.exe) do set nasm=%%~$PATH:G
if "%nasm%"=="" echo NASM not detected! http://www.nasm.us/ | %tee%
echo.

:mingwupdate
for %%G in (mingw-get.exe) do set mingwget=%%~$PATH:G
if "%mingwget%"=="" (
echo Fatal Error: MinGW-Get not detected! | %tee%
goto mingwupdate_end
)

mingw-get.exe update 2>&1 | %tee%

for %%G in (mingw-developer-toolkit mingw32-autoconf mingw32-automake mingw32-autotools mingw32-base mingw32-basic-bsdtar mingw32-binutils mingw32-bzip2 mingw32-libbz2 mingw32-cygutils mingw32-cygutils-dos2unix mingw32-dos2unix mingw32-expat mingw32-libexpat mingw32-gcc-tools-epoch2-autoconf mingw32-gcc-tools-epoch2-automake mingw32-gcc mingw32-libgcc mingw32-gcc-ada mingw32-libgnat mingw32-gcc-g++ mingw32-libstdc++ mingw32-gcc-fortran mingw32-libgfortran mingw32-gcc-java mingw32-gcc-objc mingw32-libobjc mingw32-libgomp mingw32-libssp mingw32-libquadmath mingw32-gdb mingw32-gdb-python mingw32-gendef mingw32-gettext mingw32-libintl mingw32-libgettextpo mingw32-libasprintf mingw32-gmp mingw32-libgmp mingw32-libgmpxx mingw32-libarchive mingw32-bsdtar mingw32-bsdcpio mingw32-libiconv mingw32-libcharset mingw32-libtool mingw32-libltdl mingw32-libunistring mingw32-lua mingw32-make mingw32-mgwport mingw32-mingw-get mingw32-pkginfo mingw32-mingw-utils mingw32-mpc mingw32-libmpc mingw32-mpfr mingw32-libmpfr mingw32-pdcurses mingw32-libpdcurses mingw32-pexports mingw32-popt mingw32-libpopt mingw32-pthreads-w32 mingw32-libpthreadgc mingw32-libpthreadgce mingw32-libquserex mingw32-mingwrt mingw32-w32api mingw32-xz mingw32-liblzma mingw32-zlib mingw32-libz mingw32-minizip mingw32-libminizip msys-autoconf msys-autogen msys-libopts msys-automake msys-tiny msys-base msys-bash msys-binutils msys-bison msys-bzip2 msys-libbz2 msys-console msys-core msys-coreutils msys-crypt msys-libcrypt msys-cvs msys-cygutils msys-dash msys-diffstat msys-diffutils msys-dos2unix msys-expat msys-libexpat msys-file msys-libmagic msys-findutils msys-locate msys-flex msys-gawk msys-gcc msys-gdbm msys-libgdbm msys-gettext msys-libintl msys-libgettextpo msys-libasprintf msys-gmp msys-libgmp msys-grep msys-groff msys-guile msys-libguile msys-gzip msys-help2man msys-inetutils msys-less msys-libarchive msys-bsdtar msys-bsdcpio msys-libiconv msys-libcharset msys-libtool msys-libltdl msys-libxml2 msys-lndir msys-lpr-enhanced msys-m4 msys-make msys-man msys-minires msys-libminires msys-mintty msys-mksh msys-mktemp msys-openssh msys-openssl msys-libopenssl msys-patch msys-perl msys-popt msys-libpopt msys-rebase msys-regex msys-libregex msys-rsync msys-rxvt msys-sed msys-system-builder msys-tar msys-termcap msys-libtermcap msys-texinfo msys-unzip msys-vim msys-w32api msys-wget msys-xz msys-liblzma msys-zip msys-zlib msys-minizip msys-libminizip) do (
mingw-get.exe install %%~G 2>&1 | %tee%
mingw-get.exe upgrade %%~G 2>&1 | %tee%
)
:mingwupdate_end

:deletemingwmake
if exist "%msys%\make.exe" if exist "%mingw%\make.exe" del /f /q "%mingw%\make.exe"

:end
echo MinGW EDuke32 Setup Helper finished at: %date% %time% | %tee%
echo. | %tee%
popd
endlocal

pause
